import Taro, { request } from '@tarojs/taro';
import { BASE_SERVER_URL } from '../constants/index';

type ResponseDataEntity = {
  code: number;
  msg: string;
  data: any;
  [propName: string]: any;
};

type ResponseEntity = {
  data: ResponseDataEntity;
  [propName: string]: any;
};

const fetch = (entity: request.Param) => {
  return Taro.request({
    ...entity,
    header: {
      token: '',
    },
    url: BASE_SERVER_URL + entity.url,
  }).then(({ data }: ResponseEntity) => {
    if (data.code === 1000) {
      return data;
    }
    throw data;
  });
};

export default fetch;
