import { ComponentClass } from 'react';
import Taro, { Component, Config } from '@tarojs/taro';
import { View, Button } from '@tarojs/components';

import './index.scss';
import { login } from '../../api/login';

type PageStateProps = {
  counter: {
    num: number;
  };
};

type PageDispatchProps = {};

type PageOwnProps = {};

type PageState = {
  loadingText: string;
};

type IProps = PageStateProps & PageDispatchProps & PageOwnProps;

interface Index {
  props: IProps;
  state: PageState;
}

class Index extends Component {
  config: Config = {};

  constructor(props) {
    super(props);
    this.state = {
      loadingText: 'Loading...',
    };
  }

  componentWillMount() {
    Taro.getStorage({
      key: 'token',
    })
      .then(res => {
        console.log(res);
      })
      .catch(() => {
        this.loginHandle();
      });
  }

  loginHandle() {
    Taro.login().then(res => {
      console.log(res);
      login({
        code: res.code,
      })
        .then(res => {
          const data = res.data;
        })
        .catch(err => {
          console.log(err);
          this.setState({
            loadingText: '',
          });
        });
      // Taro.setStorage({ key: 'token', data: res.code });
    });
  }

  navToLogin() {
    this.loginHandle();
    // Taro.navigateTo({
    //   url: '/pages/Register/Register',
    // });
  }
  render() {
    const { loadingText } = this.state;
    return (
      <View className='Index'>
        <View className='Index-loading-text'>{loadingText}</View>
        <Button className='dec_btn' onClick={this.navToLogin}>
          登录
        </Button>
      </View>
    );
  }
}

export default Index as ComponentClass<IProps, PageState>;
