import User from '../../types/User/User';
import Action from '../../types/Store/Actions';

export interface StoreState extends User {
  login: boolean;
  token: string;
}

const INITIAL_STATE = {
  login: false,
  token: '',
  id: '',
  campusId: null,
  campusName: '',
  schoolId: null,
  name: '',
  headPic: '',
};

export const updateUserInfo = (entity: User): Action => ({
  type: 'UPDATE_USERINFO',
  payload: entity,
});

export default function userinfo(
  state: StoreState = INITIAL_STATE,
  actions: Action,
): StoreState {
  switch (actions.type) {
    case 'UPDATE_USERINFO':
      return {
        ...state,
        ...actions.payload,
      };
    default:
      return state;
  }
}
